<template>
    <div v-if="state">
        <slot
            :current-refinement="currentRefinement"
            :is-search-stalled="state.isSearchStalled"
            :refine="state.refine"
        >
            <form
                class="search-form"
                action=""
                @submit.prevent="onFormSubmit"
            >
                <material-field
                    class="search-input mdc-text-field--with-leading-icon"
                    :placeholder="placeholder"
                    v-model="currentRefinement"
                    type="search"
                    @focus="$emit('focus', $event)"
                    @blur="$emit('blur', $event)"
                    @reset="$emit('reset')"
                >
                    <template v-slot:leading-icon>
                        <material-textfield-icon icon="fa-search" type="leading" />
                    </template>
                    <template v-slot:trailing-icon>
                        <button
                            v-show="currentRefinement"
                            @click="onClearClick"
                            type="button"
                            class="input-button"
                            data-tooltip-id="search-clear-tooltip"
                        >
                            <svg-icon icon="times" />
                        </button>
                        <span
                            v-show="currentRefinement && canCreate"
                            class="input-separator"
                        ></span>
                        <button
                            v-show="currentRefinement && canCreate"
                            type="submit"
                            class="input-button"
                            data-tooltip-id="save-phrase-tooltip"
                        >
                            <svg-icon icon="plus" />
                        </button>
                    </template>
                </material-field>
                <material-tooltip v-show="currentRefinement" id="search-clear-tooltip">Clear</material-tooltip>
                <material-tooltip v-show="currentRefinement && canCreate" id="save-phrase-tooltip">Save</material-tooltip>
            </form>
        </slot>
    </div>
</template>

<script>
import SearchBox from 'vue-instantsearch/src/components/SearchBox';

export default {
    name: 'SearchBox',

    mixins: [SearchBox],

    props: {
        canCreate: {
            type: Boolean,
            required: true,
        },
        dictionary: {
            type: Object,
            required: false,
        },
    },

    methods: {
        onFormSubmit() {
            axios.post(`dictionaries/${this.dictionary.id}/phrase`, {
                    phrase: this.currentRefinement,
                })
                .then(() => {
                    this.$toasted.show('Created phrase', {
                        icon: 'check-circle',
                    });

                    this.currentRefinement = '';

                    this.$emit('phrase-created');
                })
                .catch(error => {
                    this.$toasted.global.apiError(error);
                });
        },
        onClearClick() {
            this.currentRefinement = '';
        },
    },
};
</script>
<style>
.input-separator {
    align-items: center;
    height: 65%;
    border-left: 1px solid black;
    margin-left: 10px;
    margin-right: 10px;
}

.search-form {
    display: flex;
}

.search-form .mdc-text-field {
    align-items: center;
}

.input-button {
    border: 0;
    cursor: pointer;
    padding: .6rem;
    background: none;
}

@media screen and (max-width: 360px) {
    .search-form {
        width: 100%;
    }

    .search-form .mdc-text-field {
        width: 100%;
    }
}

input[type="search"]::-webkit-search-decoration,
input[type="search"]::-webkit-search-cancel-button,
input[type="search"]::-webkit-search-results-button,
input[type="search"]::-webkit-search-results-decoration {
    /* Hides the clear button on search inputs in Chrome */
    -webkit-appearance: none;
}
</style>
